// Code generated by protoc-gen-go. DO NOT EDIT.
// source: Route.proto

package Route // import "github.com/danos/vyatta-dataplane/protobuf/go/Route"

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"
import IPAddress "github.com/danos/vyatta-dataplane/protobuf/go/IPAddress"
import IPAddressOrLabel "github.com/danos/vyatta-dataplane/protobuf/go/IPAddressOrLabel"

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

type Path_PathType int32

const (
	// Packet should be dropped
	Path_BLACKHOLE Path_PathType = 0
	// Packet should generate ICMP unreachable
	Path_UNREACHABLE Path_PathType = 1
	// Packet should be subject to local delivery
	Path_LOCAL Path_PathType = 2
	// Unicast packet forwarding
	Path_UNICAST Path_PathType = 3
)

var Path_PathType_name = map[int32]string{
	0: "BLACKHOLE",
	1: "UNREACHABLE",
	2: "LOCAL",
	3: "UNICAST",
}
var Path_PathType_value = map[string]int32{
	"BLACKHOLE":   0,
	"UNREACHABLE": 1,
	"LOCAL":       2,
	"UNICAST":     3,
}

func (x Path_PathType) Enum() *Path_PathType {
	p := new(Path_PathType)
	*p = x
	return p
}
func (x Path_PathType) String() string {
	return proto.EnumName(Path_PathType_name, int32(x))
}
func (x *Path_PathType) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(Path_PathType_value, data, "Path_PathType")
	if err != nil {
		return err
	}
	*x = Path_PathType(value)
	return nil
}
func (Path_PathType) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_Route_3c09c674c80657b6, []int{0, 0}
}

type Route_PayloadType int32

const (
	// For IP routes, n/a. For MPLS routes, either IPv4 or IPv6.
	Route_UNSPEC Route_PayloadType = 0
	Route_IPV4   Route_PayloadType = 1
	Route_IPV6   Route_PayloadType = 2
)

var Route_PayloadType_name = map[int32]string{
	0: "UNSPEC",
	1: "IPV4",
	2: "IPV6",
}
var Route_PayloadType_value = map[string]int32{
	"UNSPEC": 0,
	"IPV4":   1,
	"IPV6":   2,
}

func (x Route_PayloadType) Enum() *Route_PayloadType {
	p := new(Route_PayloadType)
	*p = x
	return p
}
func (x Route_PayloadType) String() string {
	return proto.EnumName(Route_PayloadType_name, int32(x))
}
func (x *Route_PayloadType) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(Route_PayloadType_value, data, "Route_PayloadType")
	if err != nil {
		return err
	}
	*x = Route_PayloadType(value)
	return nil
}
func (Route_PayloadType) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_Route_3c09c674c80657b6, []int{1, 0}
}

type Path struct {
	// The type of the path
	Type *Path_PathType `protobuf:"varint,1,opt,name=type,enum=Path_PathType,def=3" json:"type,omitempty"`
	// The nexthop of the path. If omitted this this indicates an
	// attached (interface) route.
	Nexthop *IPAddress.IPAddress `protobuf:"bytes,2,opt,name=nexthop" json:"nexthop,omitempty"`
	// The interface index, as determined by the kernel and
	// advertised in RTM_NEWLINK messages.
	// Currently, this should always be present, since recursive
	// route resolution isn't performed in the dataplane.
	Ifindex *uint32 `protobuf:"varint,3,opt,name=ifindex" json:"ifindex,omitempty"`
	// MPLS label stack in host byte order, with labels listed
	// from top-most (closest to L2 header) to bottom-most
	// (closest to payload). Labels should not include
	// implicit-null.
	MplsLabels []uint32 `protobuf:"varint,4,rep,packed,name=mpls_labels,json=mplsLabels" json:"mpls_labels,omitempty"`
	// Bottom-of-stack only traffic towards this destination
	MplsBosOnly *bool `protobuf:"varint,5,opt,name=mpls_bos_only,json=mplsBosOnly" json:"mpls_bos_only,omitempty"`
	// Preferred source address for originating packets destined
	// to this path
	PreferredSource *IPAddress.IPAddress `protobuf:"bytes,6,opt,name=preferred_source,json=preferredSource" json:"preferred_source,omitempty"`
	// This is a backup path. Without any other indication, this
	// indicates a PIC edge backup path and will only be used if
	// all the primary paths are unusable.
	Backup *bool `protobuf:"varint,7,opt,name=backup" json:"backup,omitempty"`
	// Recursive via MPLS label. This indicates that the path can
	// instead be resolved recursively via an MPLS label, instead
	// of directly by nexthop, interface with a label stack.
	ViaMplsLabel *uint32 `protobuf:"varint,8,opt,name=via_mpls_label,json=viaMplsLabel" json:"via_mpls_label,omitempty"`
	// The number of non-recursive labels, i.e. which can be
	// replaced by via_mpls_label. Must be <= number of
	// mpls_labels.
	NNonRecursiveLabels  *uint32  `protobuf:"varint,9,opt,name=n_non_recursive_labels,json=nNonRecursiveLabels" json:"n_non_recursive_labels,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *Path) Reset()         { *m = Path{} }
func (m *Path) String() string { return proto.CompactTextString(m) }
func (*Path) ProtoMessage()    {}
func (*Path) Descriptor() ([]byte, []int) {
	return fileDescriptor_Route_3c09c674c80657b6, []int{0}
}
func (m *Path) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Path.Unmarshal(m, b)
}
func (m *Path) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Path.Marshal(b, m, deterministic)
}
func (dst *Path) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Path.Merge(dst, src)
}
func (m *Path) XXX_Size() int {
	return xxx_messageInfo_Path.Size(m)
}
func (m *Path) XXX_DiscardUnknown() {
	xxx_messageInfo_Path.DiscardUnknown(m)
}

var xxx_messageInfo_Path proto.InternalMessageInfo

const Default_Path_Type Path_PathType = Path_UNICAST

func (m *Path) GetType() Path_PathType {
	if m != nil && m.Type != nil {
		return *m.Type
	}
	return Default_Path_Type
}

func (m *Path) GetNexthop() *IPAddress.IPAddress {
	if m != nil {
		return m.Nexthop
	}
	return nil
}

func (m *Path) GetIfindex() uint32 {
	if m != nil && m.Ifindex != nil {
		return *m.Ifindex
	}
	return 0
}

func (m *Path) GetMplsLabels() []uint32 {
	if m != nil {
		return m.MplsLabels
	}
	return nil
}

func (m *Path) GetMplsBosOnly() bool {
	if m != nil && m.MplsBosOnly != nil {
		return *m.MplsBosOnly
	}
	return false
}

func (m *Path) GetPreferredSource() *IPAddress.IPAddress {
	if m != nil {
		return m.PreferredSource
	}
	return nil
}

func (m *Path) GetBackup() bool {
	if m != nil && m.Backup != nil {
		return *m.Backup
	}
	return false
}

func (m *Path) GetViaMplsLabel() uint32 {
	if m != nil && m.ViaMplsLabel != nil {
		return *m.ViaMplsLabel
	}
	return 0
}

func (m *Path) GetNNonRecursiveLabels() uint32 {
	if m != nil && m.NNonRecursiveLabels != nil {
		return *m.NNonRecursiveLabels
	}
	return 0
}

type Route struct {
	// Prefix address of the route.
	// Currently expected to always be present.
	Prefix *IPAddressOrLabel.IPAddressOrLabel `protobuf:"bytes,1,opt,name=prefix" json:"prefix,omitempty"`
	// The length of the prefix for IP routes
	PrefixLength *uint32 `protobuf:"varint,2,opt,name=prefix_length,json=prefixLength" json:"prefix_length,omitempty"`
	// Table ID of the route. This ID encodes both VRF and PBR table IDs
	// Default is RT_TABLE_MAIN
	TableId *uint32 `protobuf:"varint,3,opt,name=table_id,json=tableId,def=254" json:"table_id,omitempty"`
	// The paths of the route. No paths is equivalent to a blackhole
	Paths []*Path `protobuf:"bytes,4,rep,name=paths" json:"paths,omitempty"`
	// Type of payload carried by this route. Currently applicable
	// only for MPLS routes
	PayloadType *Route_PayloadType `protobuf:"varint,5,opt,name=payload_type,json=payloadType,enum=Route_PayloadType,def=0" json:"payload_type,omitempty"`
	// Scope of the route. Crude routing metric, but with higher
	// number being more preferred and lower number being less
	// preferred. Should be < 256. Default is RT_SCOPE_UNIVERSE.
	Scope *uint32 `protobuf:"varint,6,opt,name=scope,def=0" json:"scope,omitempty"`
	// Routing protocol, with well known values defined by
	// linux/rtnetlink.h. Should be < 256. Default is RTPROT_ZEBRA.
	RoutingProtocol      *uint32  `protobuf:"varint,7,opt,name=routing_protocol,json=routingProtocol,def=11" json:"routing_protocol,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *Route) Reset()         { *m = Route{} }
func (m *Route) String() string { return proto.CompactTextString(m) }
func (*Route) ProtoMessage()    {}
func (*Route) Descriptor() ([]byte, []int) {
	return fileDescriptor_Route_3c09c674c80657b6, []int{1}
}
func (m *Route) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Route.Unmarshal(m, b)
}
func (m *Route) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Route.Marshal(b, m, deterministic)
}
func (dst *Route) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Route.Merge(dst, src)
}
func (m *Route) XXX_Size() int {
	return xxx_messageInfo_Route.Size(m)
}
func (m *Route) XXX_DiscardUnknown() {
	xxx_messageInfo_Route.DiscardUnknown(m)
}

var xxx_messageInfo_Route proto.InternalMessageInfo

const Default_Route_TableId uint32 = 254
const Default_Route_PayloadType Route_PayloadType = Route_UNSPEC
const Default_Route_Scope uint32 = 0
const Default_Route_RoutingProtocol uint32 = 11

func (m *Route) GetPrefix() *IPAddressOrLabel.IPAddressOrLabel {
	if m != nil {
		return m.Prefix
	}
	return nil
}

func (m *Route) GetPrefixLength() uint32 {
	if m != nil && m.PrefixLength != nil {
		return *m.PrefixLength
	}
	return 0
}

func (m *Route) GetTableId() uint32 {
	if m != nil && m.TableId != nil {
		return *m.TableId
	}
	return Default_Route_TableId
}

func (m *Route) GetPaths() []*Path {
	if m != nil {
		return m.Paths
	}
	return nil
}

func (m *Route) GetPayloadType() Route_PayloadType {
	if m != nil && m.PayloadType != nil {
		return *m.PayloadType
	}
	return Default_Route_PayloadType
}

func (m *Route) GetScope() uint32 {
	if m != nil && m.Scope != nil {
		return *m.Scope
	}
	return Default_Route_Scope
}

func (m *Route) GetRoutingProtocol() uint32 {
	if m != nil && m.RoutingProtocol != nil {
		return *m.RoutingProtocol
	}
	return Default_Route_RoutingProtocol
}

func init() {
	proto.RegisterType((*Path)(nil), "Path")
	proto.RegisterType((*Route)(nil), "Route")
	proto.RegisterEnum("Path_PathType", Path_PathType_name, Path_PathType_value)
	proto.RegisterEnum("Route_PayloadType", Route_PayloadType_name, Route_PayloadType_value)
}

func init() { proto.RegisterFile("Route.proto", fileDescriptor_Route_3c09c674c80657b6) }

var fileDescriptor_Route_3c09c674c80657b6 = []byte{
	// 571 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x64, 0x52, 0xd1, 0x6e, 0xda, 0x30,
	0x14, 0x6d, 0x80, 0x00, 0xbd, 0x69, 0x4a, 0xe6, 0x49, 0x5d, 0xb4, 0x49, 0x13, 0xa2, 0x7d, 0x60,
	0x9a, 0x0a, 0x2b, 0x6d, 0xf7, 0x80, 0xb4, 0x07, 0x82, 0x90, 0x8a, 0x96, 0x41, 0xe4, 0xb6, 0x7b,
	0xd8, 0x4b, 0xe4, 0x24, 0x2e, 0x44, 0x4b, 0x6d, 0x2b, 0x71, 0x50, 0xf3, 0x4b, 0xfb, 0x94, 0x7d,
	0xd5, 0x84, 0x93, 0xb4, 0xd3, 0xf6, 0x12, 0xf9, 0x9e, 0x7b, 0xe2, 0x7b, 0xae, 0xcf, 0x01, 0x03,
	0xf3, 0x5c, 0xd2, 0x91, 0x48, 0xb9, 0xe4, 0x6f, 0x7b, 0x4b, 0x6f, 0x16, 0x45, 0x29, 0xcd, 0xb2,
	0x0a, 0x38, 0x79, 0x06, 0xd6, 0xa9, 0x4b, 0x02, 0x9a, 0x94, 0xf8, 0xe0, 0x57, 0x13, 0x5a, 0x1e,
	0x91, 0x5b, 0xf4, 0x11, 0x5a, 0xb2, 0x10, 0xd4, 0xd6, 0xfa, 0xda, 0xf0, 0x78, 0x72, 0x3c, 0xda,
	0x83, 0xea, 0x73, 0x57, 0x08, 0x3a, 0xed, 0xdc, 0xaf, 0x96, 0xf3, 0xd9, 0xed, 0x1d, 0x56, 0x24,
	0x74, 0x06, 0x1d, 0x46, 0x9f, 0xe4, 0x96, 0x0b, 0xbb, 0xd1, 0xd7, 0x86, 0xc6, 0x04, 0x46, 0xcf,
	0xf7, 0xe3, 0xba, 0x85, 0x6c, 0xe8, 0xc4, 0x0f, 0x31, 0x8b, 0xe8, 0x93, 0xdd, 0xec, 0x6b, 0x43,
	0x13, 0xd7, 0x25, 0x3a, 0x05, 0xe3, 0x51, 0x24, 0x99, 0x9f, 0xec, 0x95, 0x64, 0x76, 0xab, 0xdf,
	0x1c, 0x9a, 0x4e, 0xc3, 0xd2, 0x30, 0xec, 0x61, 0xa5, 0x2f, 0x43, 0x03, 0x30, 0x15, 0x29, 0xe0,
	0x99, 0xcf, 0x59, 0x52, 0xd8, 0x7a, 0x5f, 0x1b, 0x76, 0xb1, 0xfa, 0xd3, 0xe1, 0xd9, 0x9a, 0x25,
	0x05, 0xba, 0x06, 0x4b, 0xa4, 0xf4, 0x81, 0xa6, 0x29, 0x8d, 0xfc, 0x8c, 0xe7, 0x69, 0x48, 0xed,
	0xf6, 0x7f, 0x8a, 0x7a, 0xcf, 0x9c, 0x5b, 0x45, 0x41, 0x27, 0xd0, 0x0e, 0x48, 0xf8, 0x33, 0x17,
	0x76, 0x47, 0xdd, 0x59, 0x55, 0xe8, 0x0c, 0x8e, 0x77, 0x31, 0xf1, 0x5f, 0xb4, 0xd9, 0x5d, 0x25,
	0xfc, 0x68, 0x17, 0x93, 0x6f, 0xb5, 0x32, 0x74, 0x09, 0x27, 0xcc, 0x67, 0x9c, 0xf9, 0x29, 0x0d,
	0xf3, 0x34, 0x8b, 0x77, 0xb4, 0x5e, 0xe4, 0x50, 0xb1, 0x5f, 0xb3, 0x15, 0x67, 0xb8, 0xee, 0x95,
	0xdb, 0x0c, 0x1c, 0xe8, 0xd6, 0xaf, 0x89, 0x4c, 0x38, 0x74, 0xdc, 0xd9, 0xfc, 0xeb, 0xcd, 0xda,
	0x5d, 0x58, 0x07, 0xa8, 0x07, 0xc6, 0xfd, 0x0a, 0x2f, 0x66, 0xf3, 0x9b, 0x99, 0xe3, 0x2e, 0x2c,
	0x0d, 0x1d, 0x82, 0xee, 0xae, 0xe7, 0x33, 0xd7, 0x6a, 0x20, 0x03, 0xea, 0xa7, 0xb7, 0x9a, 0x83,
	0xdf, 0x0d, 0xd0, 0x95, 0xcb, 0xe8, 0x03, 0xb4, 0xf7, 0x3b, 0xc5, 0x4f, 0xca, 0x2f, 0x63, 0xf2,
	0x6a, 0xf4, 0xaf, 0xbf, 0xb8, 0x22, 0xa0, 0x53, 0x30, 0xcb, 0x93, 0x9f, 0x50, 0xb6, 0x91, 0x5b,
	0xe5, 0x98, 0x89, 0x8f, 0x4a, 0xd0, 0x55, 0x18, 0x7a, 0x0f, 0x5d, 0x49, 0x82, 0x84, 0xfa, 0x71,
	0x54, 0x7a, 0x35, 0x6d, 0x4e, 0xae, 0xaf, 0x70, 0x47, 0x81, 0xcb, 0x08, 0xbd, 0x03, 0x5d, 0x10,
	0xb9, 0x2d, 0xad, 0x32, 0x26, 0xba, 0x4a, 0x06, 0x2e, 0x31, 0xf4, 0x05, 0x8e, 0x04, 0x29, 0x12,
	0x4e, 0x22, 0x5f, 0x45, 0x48, 0x57, 0x11, 0x42, 0xa3, 0x32, 0x90, 0x5e, 0xd9, 0x52, 0x31, 0x6a,
	0xdf, 0xaf, 0x6e, 0xbd, 0xc5, 0x1c, 0x1b, 0xe2, 0x05, 0x44, 0x6f, 0x40, 0xcf, 0x42, 0x2e, 0x4a,
	0xe3, 0xcc, 0xa9, 0xf6, 0x09, 0x97, 0x35, 0x3a, 0x07, 0x2b, 0xe5, 0xb9, 0x8c, 0xd9, 0xc6, 0x57,
	0x61, 0x0d, 0x79, 0xa2, 0xfc, 0x32, 0xa7, 0x8d, 0x8b, 0x0b, 0xdc, 0xab, 0x7a, 0x5e, 0xd5, 0x1a,
	0x9c, 0x83, 0xf1, 0xd7, 0x2c, 0x04, 0x50, 0x4d, 0xb3, 0x0e, 0x50, 0x17, 0x5a, 0x4b, 0xef, 0xfb,
	0x95, 0xa5, 0x55, 0xa7, 0xcf, 0x56, 0xc3, 0xb9, 0xfe, 0x71, 0xb9, 0x89, 0xe5, 0x36, 0x0f, 0x46,
	0x21, 0x7f, 0x1c, 0x47, 0x84, 0xf1, 0x6c, 0xbc, 0x2b, 0x88, 0x94, 0xe4, 0x3c, 0x22, 0x92, 0x88,
	0x84, 0x30, 0x3a, 0x56, 0x73, 0x83, 0xfc, 0x61, 0xbc, 0xe1, 0x63, 0xb5, 0xce, 0x9f, 0x00, 0x00,
	0x00, 0xff, 0xff, 0x8c, 0x89, 0x6c, 0xc1, 0x67, 0x03, 0x00, 0x00,
}
